/*
test.cs Cu̎gp
coded by isaku@pb4.so-net.ne.jp
*/

using System;
using System.IO;

class Program
{
    static StreamWriter fp;
    static uint[]ini={0x1234,0x5678,0x9abc,0xdef0};

    static uint x=123456789,y=362436069,z=521288629,w=88675123; 

    static uint xor128() { 
        uint t=(x^(x<<11)); x=y;y=z;z=w; return w=(w^(w>>19))^(t^(t>>8)); 
    }

    static void PutStr(string s) { fp.Write("{0}",s); }
    static void PutDbl(double x) { fp.Write(" {0,11:0.0000000}",x); }
    static void PutInt(int x)    { fp.Write(" {0,3}",x); }
    static void PutUsg(uint x)   { fp.Write("{0,10} ",x); }
    static void PutBit(int x)    { fp.Write("{0}",x); }
    static void PutLn1(string s) { fp.WriteLine(); fp.Write("{0,-9}",s); }
    static void PutLn2(string s) { fp.WriteLine("{0}",s); }

    static void EachDist(int m) {
        double x,y;
        double[]vec;

        for (int i=0;i<10000;i++) XorShift_m.NextMt_m(m);
        PutLn1("Unif");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextUnif_m(m));
        PutLn1("Int");
        for (int i=0;i<12;i++) PutInt(XorShift_m.NextInt_m(m,1000));
        PutLn1("IntEx");
        for (int i=0;i<12;i++) PutInt(XorShift_m.NextIntEx_m(m,1000));
        PutLn1("Chisq");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextChisq_m(m,10));
        PutLn1("Gamma");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextGamma_m(m,10));
        PutLn1("Geometric");
        for (int i=0;i<12;i++) PutInt(XorShift_m.NextGeometric_m(m,0.2));
        PutLn1("Triangle");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextTriangle_m(m));
        PutLn1("Exp");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextExp_m(m));
        PutLn1("Normal");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextNormal_m(m));
        PutLn1("UnitVect "); XorShift_m.NextUnitVect_m(m,out vec,4);
        for (int i=0;i<4;i++) PutDbl(vec[i]);
        PutLn1("Binomial");
        for (int i=0;i<12;i++) PutInt(XorShift_m.NextBinomial_m(m,10,0.3));
        PutLn1("Binormal");
        for (int i=0;i<4;i+=2) {
            XorShift_m.NextBinormal_m(m,0.3,out x,out y);
            PutDbl(x); PutDbl(y);
        }
        PutLn1("Beta");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextBeta_m(m,2.0,3.0));
        PutLn1("Power");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextPower_m(m,10));
        PutLn1("Logistic");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextLogistic_m(m));
        PutLn1("Cauchy");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextCauchy_m(m));
        PutLn1("FDist");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextFDist_m(m,10,20));
        PutLn1("Poisson");
        for (int i=0;i<12;i++) PutInt(XorShift_m.NextPoisson_m(m,2.0));
        PutLn1("TDist");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextTDist_m(m,10));
        PutLn1("Weibull");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextWeibull_m(m,0.3));
        PutLn1("Bit");
        for (int i=0;i<48;i++) PutBit(XorShift_m.NextBit_m(m));
        PutLn1("Byte");
        for (int i=0;i<12;i++) PutInt(XorShift_m.NextByte_m(m));
        PutLn1("Init"); XorShift_m.InitMt_m(m,1234);
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextUnif_m(m));
        PutLn1("InitEx"); XorShift_m.InitMtEx_m(m,ini);
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextUnif_m(m));
        PutLn2("");
    }

    static void TestDist() {
        string fname="s.txt";
        fp=new StreamWriter(fname);
        for (int m=0;m<32;m++) EachDist(m);
        fp.Close();
        Console.WriteLine("'{0}'쐬܂",fname);
    }

    static void TestSpeed() {       
        XorShift s=new XorShift(1);
        int clo,min=32767;

        for (int k=0;k<10;k++) {
            clo=Environment.TickCount;
            for (int i=0;i<100000000;i++) s.NextMt();
            clo=Environment.TickCount-clo;
            Console.Write(" {0}",clo.ToString());
            if (clo<min) min=clo;
        }
        Console.WriteLine();
        Console.WriteLine("P̎s:{0:0.000} b",min/1000.0);
    }

    static void TestSpeedXor128() {       
        int clo,min=32767;

        for (int k=0;k<10;k++) {
            clo=Environment.TickCount;
            for (int i=0;i<100000000;i++) xor128();
            clo=Environment.TickCount-clo;
            Console.Write(" {0}",clo.ToString());
            if (clo<min) min=clo;
        }
        Console.WriteLine();
        Console.WriteLine("xor128:P̎s:{0:0.000} b",min/1000.0);
    }

    static void TestSpeedRandom() {       
        int clo,min=32767; Random s=new Random(1);

        for (int k=0;k<10;k++) {
            clo=Environment.TickCount;
            for (int i=0;i<100000000;i++) s.Next();
            clo=Environment.TickCount-clo;
            Console.Write(" {0}",clo.ToString());
            if (clo<min) min=clo;
        }
        Console.WriteLine();
        Console.WriteLine("Random:P̎s:{0:0.000} b",min/1000.0);
    }

    static void Main(string[] args) {
        Console.WriteLine("Main()ɐ䂪n܂");
        TestDist();
        TestSpeed();
        TestSpeedXor128();
        TestSpeedRandom();
    }
}
