import java.io.*;

public class Test {

    static FileWriter fp;
    static int[]ini={0x1234,0x5678,0x9abc,0xdef0};

    static int x=123456789,y=362436069,z=521288629,w=88675123; 

    static int xor128() { 
        int t=(x^(x<<11)); x=y; y=z; z=w; return w=(w^(w>>>19))^(t^(t>>>8)); 
    }

    static void PutStr(String s) {
        try { fp.write(s); }
        catch (IOException e) { System.out.println("O - " + e); }
    }

    static void PutDbl(double x) { PutStr(String.format(" %11.7f",x)); }

    static void PutInt(int x) { PutStr(String.format(" %3d",x)); }

    static void PutUsg(int x) {
        double d=x;
        if (d<0) d+=4294967296.0;
        PutStr(String.format("%10.0f ",d));
    }

    static void PutBit(int x) { PutStr(String.format("%d",x)); }

    static void PutLn1(String s) {
        PutStr(System.getProperty("line.separator"));
        PutStr(String.format("%-9s",s));
    }

    static void PutLn2(String s) {
        PutStr(String.format("%s",s));
        PutStr(System.getProperty("line.separator"));
    }

    static void EachDist(int m) {
        double[]vec;

        for (int i=0;i<10000;i++) XorShift_m.NextMt_m(m);
        PutLn1("Unif");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextUnif_m(m));
        PutLn1("Int");
        for (int i=0;i<12;i++) PutInt(XorShift_m.NextInt_m(m,1000));
        PutLn1("IntEx");
        for (int i=0;i<12;i++) PutInt(XorShift_m.NextIntEx_m(m,1000));
        PutLn1("Chisq");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextChisq_m(m,10));
        PutLn1("Gamma");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextGamma_m(m,10));
        PutLn1("Geometric");
        for (int i=0;i<12;i++) PutInt(XorShift_m.NextGeometric_m(m,0.2));
        PutLn1("Triangle");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextTriangle_m(m));
        PutLn1("Exp");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextExp_m(m));
        PutLn1("Normal");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextNormal_m(m));
        PutLn1("UnitVect "); vec=XorShift_m.NextUnitVect_m(m,4);
        for (int i=0;i<4;i++) PutDbl(vec[i]);
        PutLn1("Binomial");
        for (int i=0;i<12;i++) PutInt(XorShift_m.NextBinomial_m(m,10,0.3));
        PutLn1("Binormal");
        for (int i=0;i<4;i+=2) {
            vec=XorShift_m.NextBinormal_m(m,0.3);
            PutDbl(vec[0]); PutDbl(vec[1]);
        }
        PutLn1("Beta");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextBeta_m(m,2.0,3.0));
        PutLn1("Power");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextPower_m(m,10));
        PutLn1("Logistic");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextLogistic_m(m));
        PutLn1("Cauchy");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextCauchy_m(m));
        PutLn1("FDist");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextFDist_m(m,10,20));
        PutLn1("Poisson");
        for (int i=0;i<12;i++) PutInt(XorShift_m.NextPoisson_m(m,2.0));
        PutLn1("TDist");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextTDist_m(m,10));
        PutLn1("Weibull");
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextWeibull_m(m,0.3));
        PutLn1("Bit");
        for (int i=0;i<48;i++) PutBit(XorShift_m.NextBit_m(m));
        PutLn1("Byte");
        for (int i=0;i<12;i++) PutInt(XorShift_m.NextByte_m(m));
        PutLn1("Init"); XorShift_m.InitMt_m(m,1234);
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextUnif_m(m));
        PutLn1("InitEx"); XorShift_m.InitMtEx_m(m,ini);
        for (int i=0;i<4;i++) PutDbl(XorShift_m.NextUnif_m(m));
        PutLn2("");
    }

    static void TestDist() {
        String fname = "j.txt";

        try {
            fp=new FileWriter(fname);
            for (int m=0;m<32;m++) EachDist(m);
            fp.close();
        }
        catch (IOException e) { System.out.println("O - " + e); }
        System.out.println("'" + fname + "'쐬܂");
    }


    static void TestSpeed() {       
        XorShift s=new XorShift(1);
        long clo,min=32767;

        for (int k=0;k<10;k++) {
            clo=System.currentTimeMillis();
            for (int i=0;i<100000000;i++) s.NextMt();
            clo=System.currentTimeMillis()-clo;
            System.out.print(" " + clo);
            if (clo<min) min=clo;
        }
        System.out.println();
        System.out.println("P̎s " + min/1000.0 + " b");
    }

    static void TestSpeedOriginal() {       
        long clo,min=32767;

        for (int k=0;k<10;k++) {
            clo=System.currentTimeMillis();
            for (int i=0;i<100000000;i++) xor128();
            clo=System.currentTimeMillis()-clo;
            System.out.print(" " + clo);
            if (clo<min) min=clo;
        }
        System.out.println();
        System.out.println("xor128:P̎s " + min/1000.0 + " b");
    }

    public static void main(String[]args) {
        System.out.println("main()ɐ䂪n܂");
        TestDist();
        TestSpeed();
        TestSpeedOriginal();
    }
}
