Imports System
Imports System.IO

Module MainModule
    Dim fp As StreamWriter
    Dim ini As UInteger() = {&H1234, &H5678, &H9ABC, &HDEF0}
    Dim x As UInteger = 123456789
    Dim y As UInteger = 362436069
    Dim z As UInteger = 521288629
    Dim w As UInteger = 88675123

    Function xor128() As UInteger
        Dim t As UInteger

        t = x Xor (x << 11) : x = y : y = z : z = w
        w = w Xor (w >> 19) Xor t Xor (t >> 8) : xor128 = w
    End Function

    Sub PutStr(ByVal s As String)
        fp.Write("{0}", s)
    End Sub

    Sub PutDbl(ByVal x As Double)
        fp.Write(" {0,11:0.0000000}", x)
    End Sub

    Sub PutInt(ByVal x As Integer)
        fp.Write(" {0,3}", x)
    End Sub

    Sub PutUsg(ByVal x As UInteger)
        fp.Write("{0,10} ", x)
    End Sub

    Sub PutBit(ByVal x As Integer)
        fp.Write("{0}", x)
    End Sub

    Sub PutLn1(ByVal s As String)
        fp.WriteLine()
        fp.Write("{0,-9}", s)
    End Sub

    Sub PutLn2(ByVal s As String)
        fp.WriteLine("{0}", s)
    End Sub

    Sub EachDist(ByVal m As Integer)
        Dim i As Integer
        Dim vec(3) As Double
        Dim x, y As Double

        For i = 1 To 10000 : XorShift_m.NextMt_m(m) : Next i
        PutLn1("Unif")
        For i = 1 To 4 : PutDbl(XorShift_m.NextUnif_m(m)) : Next
        PutLn1("Int")
        For i = 1 To 12 : PutInt(XorShift_m.NextInt_m(m, 1000)) : Next
        PutLn1("IntEx")
        For i = 1 To 12 : PutInt(XorShift_m.NextIntEx_m(m, 1000)) : Next
        PutLn1("Chisq")
        For i = 1 To 4 : PutDbl(XorShift_m.NextChisq_m(m, 10.0#)) : Next
        PutLn1("Gamma")
        For i = 1 To 4 : PutDbl(XorShift_m.NextGamma_m(m, 10.0#)) : Next
        PutLn1("Geometric")
        For i = 1 To 12 : PutInt(XorShift_m.NextGeometric_m(m, 0.2)) : Next
        PutLn1("Triangle")
        For i = 1 To 4 : PutDbl(XorShift_m.NextTriangle_m(m)) : Next
        PutLn1("Exp")
        For i = 1 To 4 : PutDbl(XorShift_m.NextExp_m(m)) : Next
        PutLn1("Normal")
        For i = 1 To 4 : PutDbl(XorShift_m.NextNormal_m(m)) : Next
        PutLn1("UnitVect")
        XorShift_m.NextUnitVect_m(m, vec, 4)
        For i = 1 To 4 : PutDbl(vec(i - 1)) : Next
        PutLn1("Binomial")
        For i = 1 To 12 : PutInt(XorShift_m.NextBinomial_m(m, 10, 0.3)) : Next
        PutLn1("Binormal")
        For i = 1 To 4 \ 2
            XorShift_m.NextBinormal_m(m, 0.3, x, y) : PutDbl(x) : PutDbl(y)
        Next i
        PutLn1("Beta")
        For i = 1 To 4 : PutDbl(XorShift_m.NextBeta_m(m, 2.0#, 3.0#)) : Next
        PutLn1("Power")
        For i = 1 To 4 : PutDbl(XorShift_m.NextPower_m(m, 10.0#)) : Next
        PutLn1("Logistic")
        For i = 1 To 4 : PutDbl(XorShift_m.NextLogistic_m(m)) : Next
        PutLn1("Cauchy")
        For i = 1 To 4 : PutDbl(XorShift_m.NextCauchy_m(m)) : Next
        PutLn1("FDist")
        For i = 1 To 4 : PutDbl(XorShift_m.NextFDist_m(m, 10.0#, 20.0#)) : Next
        PutLn1("Poisson")
        For i = 1 To 12 : PutInt(XorShift_m.NextPoisson_m(m, 2.0#)) : Next
        PutLn1("TDist")
        For i = 1 To 4 : PutDbl(XorShift_m.NextTDist_m(m, 10)) : Next
        PutLn1("Weibull")
        For i = 1 To 4 : PutDbl(XorShift_m.NextWeibull_m(m, 0.3)) : Next
        PutLn1("Bit")
        For i = 1 To 48 : PutBit(XorShift_m.NextBit_m(m)) : Next
        PutLn1("Byte")
        For i = 1 To 12 : PutInt(XorShift_m.NextByte_m(m)) : Next
        PutLn1("Init")
        XorShift_m.InitMt_m(m, 1234)
        For i = 1 To 4 : PutDbl(XorShift_m.NextUnif_m(m)) : Next
        PutLn1("InitEx")
        XorShift_m.InitMtEx_m(m, ini)
        For i = 1 To 4 : PutDbl(XorShift_m.NextUnif_m(m)) : Next
        PutLn2("")
    End Sub


    Sub TestDist()
        Dim fname As String = "v.txt"
        Dim m As Integer

        fp = new StreamWriter(fname)
        For m=0 To 31 : EachDist(m) : Next
        fp.Close()
        Console.WriteLine("'{0}'쐬܂", fname)
    End Sub

    Sub TestSpeed()
        Dim i, j, clo, min As Integer
        Dim s As XorShift = New XorShift(1)

        min = 32767
        For i = 1 To 10
            clo = Environment.TickCount
            For j = 1 To 100000000 : s.NextMt() : Next
            clo = Environment.TickCount - clo
            Console.Write(" {0}", clo)
            If clo < min Then min = clo
        Next
        Console.WriteLine()
        Console.WriteLine("P̎s:{0:0.000} b", min / 1000.0)
    End Sub

    Sub TestSpeedXor128()
        Dim i, j, clo, min As Integer

        min = 32767
        For i = 1 To 10
            clo = Environment.TickCount
            For j = 1 To 100000000 : xor128() : Next
            clo = Environment.TickCount - clo
            Console.Write(" {0}", clo)
            If clo < min Then min = clo
        Next
        Console.WriteLine()
        Console.WriteLine("xor128:P̎s:{0:0.000} b", min / 1000.0)
    End Sub

    Sub TestSpeedRnd()
        Dim i, j, clo, min As Integer

        min = 32767
        For i = 1 To 10
            clo = Environment.TickCount
            For j = 1 To 100000000 : Rnd() : Next
            clo = Environment.TickCount - clo
            Console.Write(" {0}", clo)
            If clo < min Then min = clo
        Next
        Console.WriteLine()
        Console.WriteLine("Rnd:P̎s:{0:0.000} b", min / 1000.0)
    End Sub

    Sub TestSpeedRandom()
        Dim i, j, clo, min As Integer
        Dim s As Random = New Random(1)

        min = 32767
        For i = 1 To 10
            clo = Environment.TickCount
            For j = 1 To 100000000 : s.NextDouble() : Next
            clo = Environment.TickCount - clo
            Console.Write(" {0}", clo)
            If clo < min Then min = clo
        Next
        Console.WriteLine()
        Console.WriteLine("Random.Next:P̎s:{0:0.000} b", min / 1000.0)
    End Sub

    Sub Main()
        Console.WriteLine("Main()ɐ䂪n܂")
        TestDist()
        TestSpeed()
        TestSpeedXor128()
        TestSpeedRnd()
        TestSpeedRandom()
    End Sub

End Module
