/*
XorShift.java Cu
coded by isaku@pb4.so-net.ne.jp
*/

class XorShift
{
    int    x,y,z,w; /* ԃe[u */
    int    coin_bits; /* NextBit ł̎c̃rbg */
    int    coin_save; /* NextBit ł̒lێ */
    int    byte_pos;  /* NextByte ŎgpoCg */
    int    byte_save; /* NextByte ł̒lێ */
    int    range; /* NextIntEx őO͈̔ */
    int    base; /* NextIntEx őO̊l */
    int    shift; /* NextIntEx őÕVtg */
    int    normal_sw; /* NextNormal ŎcĂ */
    double normal_save; /* NextNormal ̎c̒l */

    /* ̂` */
    int InitMtSub(int s,int i) { return 1812433253*(s^(s>>>30))+i+1; }

    /* ̎ s ɂ鏉 */
    /*synchronized*/ public void InitMt(int s) {
        x=InitMtSub(s,0); y=InitMtSub(x,1); z=InitMtSub(y,2); w=InitMtSub(z,3);
        range=0; normal_sw=0; coin_bits=0; byte_pos=0;
    }

    XorShift(int s) { InitMt(s); }

    /* z key ɂ鏉 */
    /*synchronized*/ public void InitMtEx(int[]key) {
        int i,k,s,len=key.length; int[]v=new int[4];

        InitMt(1); v[0]=x; v[1]=y; v[2]=z; v[3]=w; s=w;
        for (i=0;i<len;i++)   v[i&3]^=s=InitMtSub(s,key[i]+i);
        for (k=0;k<3;k++,i++) v[i&3]^=s=InitMtSub(s,k);
        x=v[0]; y=v[1]; z=v[2]; w=v[3];
        if (x==0&&y==0&&z==0&&w==0) x=0;
    }

    XorShift(int[]key) { InitMtEx(key); }

    /* 32rbg萮̗ */
    /*synchronized*/ public int NextMt()
    { int t=x^(x<<11); x=y; y=z; z=w; return w=w^(w>>>19)^t^(t>>>8); }

    /* Oȏ n ̐ */
    public int NextInt(int n) {
        double a=NextMt();
        if (a<0) a+=4294967296.0;
        return(int)(n*(1.0/4294967296.0)*a);
    }

    /* OȏP̗(53bitx) */
    public double NextUnif() {
        double a=NextMt()>>>11,b=NextMt();
        if (b<0) b+=4294967296.0;
        return(b*2097152.0+a)*(1.0/9007199254740992.0);
    }

    /* OPԂ */
    public int NextBit() {
        if (--coin_bits==-1)
        { coin_bits=31; return(int)(coin_save=NextMt())&1; }
        else return(int)(coin_save>>>=1)&1;
    }

    /* OQTTԂ */
    public int NextByte() {
        if (--byte_pos==-1)
        { byte_pos=3; return(int)(byte_save=NextMt())&255; }
        else return(int)(byte_save>>>=8)&255;
    }

    /* ۂߌ덷̂ȂOȏ range_ ̐ */
    /*synchronized*/ public int NextIntEx(int range_) {
        int y_,base_,remain_; int shift_;

        if (range_<=0) return 0;
        if (range_!=range) {
            base=(range=range_);
            for (shift=0;base<=(1<<30)&&base!=1<<31;shift++) base<<=1;
        }
        for (;;) {
            y_=NextMt()>>>1;
            if (y_<base||base==1<<31) return(int)(y_>>>shift);
            base_=base; shift_=shift; y_-=base_;
            remain_=(1<<31)-base_;
            for (;remain_>=(int)range_;remain_-=base_) {
                for (;base_>remain_;base_>>>=1) shift_--;
                if (y_<base_) return(int)(y_>>>shift_);
                else y_-=base_;
            }
        }
    }

    /* Rx˂̃JCQ敪z */
    public double NextChisq(double n)
    { return 2*NextGamma(0.5*n); }

    /* p[^̃K}z */
    public double NextGamma(double a) {
        double t,u,X,Y;
        if (a>1) {
            t=Math.sqrt(2*a-1);
            do {
                do {
                    do {
                        X=1-NextUnif();
                        Y=2*NextUnif()-1;
                    } while (X*X+Y*Y>1);
                    Y/=X; X=t*Y+a-1;
                } while (X<=0);
                u=(a-1)*Math.log(X/(a-1))-t*Y;
            } while (u<-50||NextUnif()>(1+Y*Y)*Math.exp(u));
        } else {
            t=2.718281828459045235/(a+2.718281828459045235);
            do {
                if (NextUnif()<t) {
                    X=Math.pow(NextUnif(),1/a); Y=Math.exp(-X);
                } else {
                    X=1-Math.log(1-NextUnif()); Y=Math.pow(X,a-1);
                }
            } while (NextUnif()>=Y);
        }
        return X;
    }

    /* mo̊􉽕z */
    public int NextGeometric(double p)
    { return(int)Math.ceil(Math.log(1.0-NextUnif())/Math.log(1-p)); }

    /* Opz */
    public double NextTriangle()
    { double a=NextUnif(),b=NextUnif(); return a-b; }

    /* ςP̎wz */
    public double NextExp()
    { return-Math.log(1-NextUnif()); }

    /* WKz(ő8.57) */
    /*synchronized*/ public double NextNormal()
    {
        if (normal_sw==0) {
            double t=Math.sqrt(-2*Math.log(1.0-NextUnif()));
            double u=3.141592653589793*2*NextUnif();
            normal_save=t*Math.sin(u); normal_sw=1;
            return t*Math.cos(u);
        }else{ normal_sw=0; return normal_save; }
    }

    /* m̃_PʃxNg */
    public double[]NextUnitVect(int n) {
        int i; double r=0; double[]v=new double[n];
        for (i=0;i<n;i++) { v[i]=NextNormal(); r+=v[i]*v[i]; }
        if (r==0.0) r=1.0;
        r=Math.sqrt(r);
        for (i=0;i<n;i++) v[i]/=r;
        return v;
    }

    /* p[^m,ôQz */
    public int NextBinomial(int n,double p) {
        int i,r=0;
        for (i=0;i<n;i++) if (NextUnif()<p) r++;
        return r;
    }

    /* ֌Wq̂QϗʐKz */
    public double[]NextBinormal(double r) {
        double r1,r2,s;
        do {
            r1=2*NextUnif()-1;
            r2=2*NextUnif()-1;
            s=r1*r1+r2*r2;
        } while (s>1||s==0);
        s= -Math.log(s)/s; r1=Math.sqrt((1+r)*s)*r1;
        r2=Math.sqrt((1-r)*s)*r2;
        return new double[]{r1+r2,r1-r2};
    }

    /* p[^`,ãx[^z */
    public double NextBeta(double a,double b) {
        double temp=NextGamma(a);
        return temp/(temp+NextGamma(b));
    }

    /* p[^m̗ݏ敪z */
    public double NextPower(double n)
    { return Math.pow(NextUnif(),1.0/(n+1)); }

    /* WXeBbNz */
    public double NextLogistic() {
        double r;
        do r=NextUnif(); while (r==0);
        return Math.log(r/(1-r));
    }

    /* R[V[z */
    public double NextCauchy() {
        double x,y;
        do { x=1-NextUnif(); y=2*NextUnif()-1; }
        while (x*x+y*y>1);
        return y/x;
    }

    /* Rx n1,n2 ̂ez */
    public double NextFDist(double n1,double n2) {
        double nc1=NextChisq(n1),nc2=NextChisq(n2);
        return (nc1*n2)/(nc2*n1);
    }

    /* σɂ̃|A\z */
    public int NextPoisson(double lambda) {
        int k; lambda=Math.exp(lambda)*NextUnif();
        for (k=0;lambda>1;k++) lambda*=NextUnif();
        return k;
    }

    /* Rxm̂z */
    public double NextTDist(double n) {
        double a,b,c;
        if (n<=2) {
            do a=NextChisq(n); while (a==0);
            return NextNormal()/Math.sqrt(a/n);
        }
        do {
            a=NextNormal(); b=a*a/(n-2);
            c=Math.log(1-NextUnif())/(1-0.5*n);
        } while (Math.exp(-b-c)>1-b);
        return a/Math.sqrt((1-2.0/n)*(1-b));
    }

    /* p[^̃Cuz */
    public double NextWeibull(double alpha)
    { return Math.pow(-Math.log(1-NextUnif()),1/alpha); }
}
